import josx.platform.rcx.*;

public class FollowTheLine {

	private Sensor S1;	// Lichtsensor
	private Sensor S2;	// Berhrungssensor 1
	private Sensor S3;	// Berhrungssensor 2
	
	private Motor M_left;	// linker Motor
	private Motor M_right;	// rechter Motor
	
	int floor;	// Untergrundhelligkeitswert
	int line;	// Linienhelligkeitswert
	int border;	// Grenzwert zw. Linie und Untergrund
	
	public FollowTheLine(Sensor sens1, Sensor sens2, Sensor sens3, Motor left, Motor right ) {
		
		M_left = left;
		M_right = right;
		
		S1 = sens1;
		S2 = sens2;
		S3 = sens3;
		
		M_left.setPower(6);
		M_right.setPower(6);
	
		border=0;
		
		justieren(); // Linchtsensor einstellen
		go(); // Na dann mal los...
		
	}
	
	// Lichtsensor einstellen
	public void justieren() {
		
		// Untergrund einlesen
		
		TextLCD.print("floor"); sleep(1000);
		TextLCD.print("press"); sleep(1000);
		TextLCD.print("VIEW");
		Sound.beep();
		
		while (!Button.VIEW.isPressed()) {
			floor=0;
		}
		while (Button.VIEW.isPressed()) {
			floor = Math.max(getValue(),floor);
		}
		
		// Linie einlesen
		
		TextLCD.print("line"); sleep(1000);
		TextLCD.print("press"); sleep(1000);
		TextLCD.print("VIEW");
		Sound.beep();
		
		while (!Button.VIEW.isPressed()) {
			line=0;
		}
		while (Button.VIEW.isPressed()) {
			line = Math.max(getValue(),line);
		}
		
		// Grenze berechnen
		border = (floor+line)/2;
		LCD.showNumber(border);
		Sound.beepSequence();
		sleep(1000);
	}
	
	public void go() {
		TextLCD.print("Busy");
		boolean foundleft = true;
		
		// so lange fahren, bis Run gedrckt wurde
		while (!Button.RUN.isPressed()) {
		drive_normal();
		
		// Wenn nicht mehr auf der Linie
			if (!ontheline()) {
				int time = 5;
				int i;
				for (i=0; i<3 && !ontheline(); i++) {
					// erst mal kurz nach Links drehen...
					int c=0;
					if (foundleft)
						steer_left();
					else
						steer_right();
		
					while (!ontheline() && c++<time)
						sleep(1);
						time *= 3;
					// wieder drauf? dann ok
						if (ontheline())
							break;
					// dreimal so lange nach rechts drehen...
						c=0;
						if (foundleft)
							steer_right();
						else
							steer_left();
					while (!ontheline() && c++<time)
						sleep(1);
						time *= 3;
					// wieder drauf? dann ok
						if (ontheline()) {
							foundleft = !foundleft;
							break;
						}
				} // Ende der For-Schleife
				if (i>=5)
					break;
		} // Ende der if-Bedingung if (!ontheline)
		} // Ausfhrung nach Button-Druck
		
		stop();
		TextLCD.print("Stop");
		sleep(1000);
	}
	
	// Sensor S1 gibt Einlesewert zurck
	int getValue() {
		return Sensor.S1.readRawValue();
	}
	
	// Ist Robo auf der Linie?
	boolean ontheline() {
		boolean on = getValue() > border; 
		return on;
	}
	
	// Vorwrts fahren
	private void drive_normal() {
		M_left.forward();
		M_right.forward();
	}
	
	// Nach links lenken
	private void steer_left() {
		M_left.backward();
		M_right.forward();
	}
	
	// Nach rechts lenken
	private void steer_right() {
		M_right.backward();
		M_left.forward();
	}
	
	// Robo anhalten
	private void stop() {
		M_left.stop();
		M_right.stop();
	}
	
	// Pause
	private void sleep(int milis) {
		try {
		Thread.sleep(milis);

		}
		catch(Exception e){}
		}
		
	public static void main(String[] args) {
		
		// Sensoren aktivieren
		Sensor.S1.activate();
		Sensor.S2.activate();
		Sensor.S3.activate();
		Sensor.S1.setTypeAndMode(SensorConstants.SENSOR_TYPE_TOUCH,
		SensorConstants.SENSOR_MODE_BOOL);
		Sensor.S2.setTypeAndMode(SensorConstants.SENSOR_TYPE_LIGHT,
		SensorConstants.SENSOR_MODE_PCT);
		Sensor.S3.setTypeAndMode(SensorConstants.SENSOR_TYPE_TOUCH,
		SensorConstants.SENSOR_MODE_BOOL);
				
		FollowTheLine f = new FollowTheLine(Sensor.S1, Sensor.S2, Sensor.S3, Motor.A, Motor.C);
		
	}
	
}
